
.data
IID_IPicture   dd  07bf80980h
               dw  0bf32h
               dw  0101ah
               db  08bh,0bbh,0,0aah,0,030h,0ch,0abh

.data?
hBitmap        dd  ?
GifOn          dd  ?
CXSCREEN       dd  ?
CYSCREEN       dd  ?
ipPicture      dd  ?
hImage         dd  ?
hPalette       dd  ?
TypePict       dd  ?
pWidth         dd  ?
pHeight        dd  ?
sHeight        dd  ?
mWidth         dd  ?
mHeight        dd  ?
negmHeight     dd  ?

.code
;===============================================================
; Load and Build the Image information PROCEDURE
;===============================================================
LoadImageFile PROC uses ebx esi edi
LOCAL    rect:RECT
LOCAL    hFile:DWORD, FileSize, hGlobal, pMem, BytesRead, ipstm, TempDC
LOCAL    hDC:DWORD, xscreenpixels, yscreenpixels, hBR, OldBitmap
LOCAL    szType[32]:BYTE

;---------- [Release the picture if available] ----------
      .if ipPicture
            mov     eax, ipPicture
           push     eax
            mov     edx, dword ptr[eax]
           call     dword ptr[edx+8]          ; ipPicture->Release()
         INVOKE     DeleteObject, hBitmap
      .endif

         and     ipPicture, 0
      INVOKE     CreateFile, addr szRootPath, GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0
      .if eax == INVALID_HANDLE_VALUE           ; We had an error
            ret
      .endif
         mov     hFile, eax

      INVOKE     GetFileSize, hFile, NULL
         mov     FileSize, eax

;---------- [Allocate Global memory for CreateStreamOnHGlobal] ----------
      INVOKE     GlobalAlloc, GMEM_MOVEABLE, FileSize
         mov     hGlobal, eax
      INVOKE     GlobalLock, hGlobal
         mov     pMem, eax

;---------- [Error conditions for the above] ----------
      .if FileSize == -1 || !hGlobal || !pMem
         INVOKE     CloseHandle, hFile
            mov     eax, -1
            ret
      .endif

;---------- [Read the file into memory] ----------
      INVOKE     ReadFile, hFile, pMem, FileSize, addr BytesRead, 0
      .if !eax || !BytesRead                        ; We had an error
         INVOKE     CloseHandle, hFile
         INVOKE     GlobalUnlock, hGlobal
         INVOKE     GlobalFree, hGlobal
            mov     eax, -1
            ret
      .endif

      INVOKE     CloseHandle, hFile

;---------- [Check for GIF type file] ----------
         and     GifOn, 0
         mov     esi, pMem
      .if dword ptr[esi] == '8FIG'
            mov     eax, dword ptr[esi]
            mov     bx, word ptr[esi+4]
            mov     dword ptr szType, eax
            mov     word ptr szType+4, bx
            mov     byte ptr szType+6, 0
            mov     GifOn, 1

      .else
         INVOKE     lstrlen, addr szRootPath
         INVOKE     lstrcpyn, addr szType, addr szRootPath[eax-3], 4
      .endif

;---------- [Check for Animated or Cursor/Icon type file] ----------
      .if szType >= 'A' && szType <= 'Z'
            add     szType, 20h
      .endif
      .if szType+1 >= 'A' && szType+1 <= 'Z'
            add     szType+1, 20h
      .endif
      .if szType+2 >= 'A' && szType+2 <= 'Z'
            add     szType+2, 20h
      .endif
         mov     ecx, 32
      .if szType == 'a' && szType+1 == 'n' && szType+2 == 'i' ||\
          szType == 'c' && szType+1 == 'u' && szType+2 == 'r' ||\
          szType == 'i' && szType+1 == 'c' && szType+2 == 'o'
            jmp     OutPut
      .endif

;---------- [Creates a stream object stored in global memory] ----------
         and     ipstm, 0
      INVOKE     CreateStreamOnHGlobal, hGlobal, TRUE, addr ipstm
      .if eax != 0 || !ipstm
         INVOKE     GlobalUnlock, hGlobal
         INVOKE     GlobalFree, hGlobal
            mov     eax, -1
            ret
      .endif

;---------- [Creates a new picture object and initializes it from the contents of a stream] ----------
      INVOKE     OleLoadPicture, ipstm, FileSize, 0, offset IID_IPicture, addr ipPicture    ; Long time !!!!
      .if eax != S_OK
         INVOKE     GlobalUnlock, hGlobal
         INVOKE     GlobalFree, hGlobal
            mov     eax, -1
            ret
      .endif

;---------- [Unlock and Free the Gobal memory] ----------
      INVOKE     GlobalUnlock, hGlobal
      INVOKE     GlobalFree, hGlobal

;---------- [Release the stream] ----------
         mov     eax, ipstm
        push     eax
         mov     edx, dword ptr[eax]
        call     dword ptr[edx+8]                ; ipstm->Release()

;---------- [Get number of pixels per logical inch, x & y] ----------
      INVOKE     GetDC, hWnd
         mov     hDC, eax
      INVOKE     GetDeviceCaps, hDC, LOGPIXELSX
         mov     xscreenpixels, eax
      INVOKE     GetDeviceCaps, hDC, LOGPIXELSY
         mov     yscreenpixels, eax
      INVOKE     ReleaseDC, hWnd, hDC

;PICTYPE_UNINITIALIZED = -1,
;PICTYPE_NONE = 0,
;PICTYPE_BITMAP = 1,
;PICTYPE_METAFILE = 2,
;PICTYPE_ICON = 3
;PICTYPE_ENHMETAFILE = 4

;---------- [Get the Windows GDI handle of the picture] ----------
         lea     eax, hImage
        push     eax
        push     ipPicture
         mov     edx, ipPicture
         mov     ecx, dword ptr[edx]
        call     dword ptr[ecx+12]               ; ipPicture->get_Handle()

;---------- [Get the Picture pallete for 256 colors only] ----------
         lea     eax, hPalette
        push     eax
        push     ipPicture
         mov     edx, ipPicture
         mov     ecx, dword ptr[edx]
        call     dword ptr[ecx+16]               ; ipPicture->get_hPal() +36 = set_hPal()

;---------- [Get the Picture type] ----------
         lea     eax, TypePict
        push     eax
        push     ipPicture
         mov     edx, ipPicture
         mov     ecx, dword ptr[edx]
        call     dword ptr[ecx+20]               ; ipPicture->get_Type()

;---------- [Get the image METRIC units for the width and height] ----------
         lea     eax, mWidth
        push     eax
        push     ipPicture
         mov     edx, ipPicture
         mov     ecx, dword ptr[edx]
        call     dword ptr[ecx+24]               ; ipPicture->get_Width()

         lea     eax, mHeight
        push     eax
        push     ipPicture
         mov     edx, ipPicture
         mov     ecx, dword ptr[edx]
        call     dword ptr[ecx+28]               ; ipPicture->get_Height()

;---------- [Convert the METRIC units to pixels] ----------
         mov     eax, mWidth
         mul     xscreenpixels 
         mov     ecx, 2540
         div     ecx
         mov     pWidth, eax
         mov     eax, mHeight
         mul     yscreenpixels 
         mov     ecx, 2540
         div     ecx
         mov     pHeight, eax
         mov     eax, mHeight
         neg     eax
         mov     negmHeight, eax                 ; Convert the mHeight to negative

;---------- [Create a Compatible Bitmap to render the picture] ----------
      INVOKE     GetDC, hWnd
         mov     hDC, eax
      INVOKE     CreateCompatibleDC, hDC
      .if !eax
            ret
      .endif
         mov     TempDC, eax
      INVOKE     CreateCompatibleBitmap, hDC, pWidth, pHeight
      .if !eax
         INVOKE     DeleteDC, TempDC
            ret
      .endif
         mov     hBitmap, eax

      INVOKE     SelectObject, TempDC, hBitmap
      .if !eax
         INVOKE     DeleteDC, TempDC
            ret
      .endif
         mov     OldBitmap, eax

;---------- [Paint the background for transparent pictures] ----------
      INVOKE     GetClientRect, hWnd, addr rect
       MOVmd     rect.right, pWidth
       MOVmd     rect.bottom, pHeight
      INVOKE     CreateSolidBrush, 0ffffffffh ;TransBG
         mov     hBR, eax
      INVOKE     FillRect, TempDC, addr rect, eax
      INVOKE     DeleteObject, hBR

;---------- [Compute thumbnail size
         mov     esi, 100
         mov     edi, 18
      .if pHeight > 18 && pHeight > 150
            mov     esi, 175
            mov     edi, 150
      .elseif pHeight > 18 && pHeight < 150
            mov     esi, 175
            mov     edi, pHeight
      .endif
      .if pWidth > esi || pHeight > edi
         .while (TRUE)
               xor     edx, edx
               mov     eax, pWidth
               mov     ebx, 10
               div     ebx
               sub     pWidth, eax
               xor     edx, edx
               mov     eax, pHeight
               mov     ebx, 10
               div     ebx
               sub     pHeight, eax
            .if pWidth <= esi && pHeight <= edi
               .break
            .endif
         .endw
      .endif

; (IPicture)pPicture::Render(hdc, x, y, cx, cy, xpos_himetric, ypos_himetric,
;                            xsize_himetric, ysize_himetric, *rectBounds)

;---------- [Render the picture] ----------
         lea     eax, rect
        push     eax                             ; Pointer to a rectangle
        push     negmHeight                      ; Image negative Height (METRIC units)
        push     mWidth                          ; Image width (METRIC units)
        push     mHeight                         ; Image height (METRIC units), Upper left corner of source
        push     0                               ; 
        push     pHeight                         ; Vertical dimension of destination rectangle
        push     pWidth                          ; Horizontal dimension of destination rectangle
        push     0                               ; Vertical coordinate in hdc at which to place the image
        push     0                               ; Horizontal coordinate in hdc at which to place the image
        push     TempDC                          ; hDC
        push     ipPicture                       ; IPicture interface pointer
         mov     eax, ipPicture
         mov     edx, dword ptr[eax]
        call     dword ptr[edx+32]               ; ipPicture->Render()       ; Long time !!!!

      .if sdword ptr eax < 0
            mov     eax, -1
      .endif
        push     eax
      INVOKE     SelectObject, TempDC, OldBitmap
      INVOKE     DeleteDC, TempDC
      INVOKE     ReleaseDC, hWnd, hDC
         pop     eax

      .if eax == -1 && ipPicture
            mov     eax, ipPicture
           push     eax
            mov     edx, dword ptr[eax]
           call     dword ptr[edx+8]             ; ipPicture->Release()
         INVOKE     DeleteObject, hBitmap
            and     ipPicture, 0
      .endif

OutPut:

         ret
LoadImageFile ENDP
